/*
 * Copyright (C) 2020  Max Regan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "printf.h"

#include "Bsp/LowPowerTaskScheduler.h"
#include "Bsp/Drivers/GpioDriver.h"
#include "Bsp/Drivers/LptimPwm.h"
#include "Bsp/Drivers/UsartDriver.h"
#include "Bsp/Drivers/LowPower.h"
#include "Bsp/macros.h"

#include "TestBoard.h"
#include "test.h"

#include "Mcu.h"

using BSP::Time;

#if defined(BOARD_WATCH)
static BSP::LptimPwm g_test_lptim(LPTIM1);
static BSP::GpioPin g_lptim_pin(g_gpioa, 7);
#elif defined(BOARD_DEVBOARD)
static BSP::GpioDriver g_gpiob(GPIOB);
static BSP::LptimPwm g_test_lptim(LPTIM2);
static BSP::GpioPin g_lptim_pin(g_gpiob, 2);
#endif

[[noreturn]] void main() {


    board_init();

#if defined(BOARD_WATCH)
    g_lptim_pin.configure_alternate_function(1);
#elif defined(BOARD_DEVBOARD)
    g_gpiob.enable();
    g_lptim_pin.configure_alternate_function(1);
#endif

    g_test_lptim.init();

    BSP::LowPower::init();

    g_test_uart.tx_blocking(test_start_text);

    BSP::time_t now = Test::get_time();
    BSP::time_t end = now + Time::seconds(3);
    g_test_uart.tx_blocking("Running...\r\n");
    while (now < end) {
        now = Test::get_time();
    }

    g_test_uart.tx_blocking("Going to sleep...\r\n");
    BSP::time_t delay = Time::seconds(3);
    BSP::RtcDriver::set_wakeup_in(delay);
    end = Test::get_time() + delay;
    while (Test::get_time() < end) {
        BSP::LowPower::stop();
    }

    g_test_uart.tx_blocking(test_pass_text);
    TEST_SPIN();
}
